



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Netty3：分隔符和定长解码器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Netty3：分隔符和定长解码器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 07:58:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>回顾TCP粘包/拆包问题解决方案</strong></p>
<p>上文详细说了TCP粘包/拆包问题产生的原因及解决方式，并以LineBasedFrameDecoder为例演示了粘包/拆包问题的实际解决方案，本文再介绍两种粘包/拆包问题的解决方案：分隔符和定长解码器。在开始本文之前，先回顾一下解决粘包/拆包问题的几个方式：</p>
<ul><li>消息长度固定，累计读取到长度总和为定长LEN的报文后，就认为读取到了一个完整的消息，将计数器重置，重新读取下一个消息</li>
<li>将回车换行符作为消息结束符，例如FTP协议，这种方式在文本协议中应用比较广泛</li>
<li>将特殊的分隔符作为消息的结束标志，回车换行符就是一种特殊的结束分隔符</li>
<li>通过在消息头中定义长度字段来标志消息的总长度</li></ul>
<p>Netty对上面4种方式做了统一的抽象，提供了4种解码器来解决对应的问题，使用起来非常方便，有了这些解码器，用户不需要自己对读取的报文进行人工解码，也不需要考虑TCP的粘包和拆包。</p>
<p><strong>基于DelimiterBasedFrameDecoder的TCP粘包/拆包解决方案</strong></p>
<p>使用DelimiterBasedFrameDecoder，我们可以自动完成以分隔符作为码流结束标志的消息的解码，下面通过例子来学习下DelimiterBasedFrameDecoder的使用。</p>
<p>首先写一个EchoServer，和TimeServer差不多，主要是加上了DelimiterBasedFrameDecoder，分隔符定为"￥_"：</p>
<div>
<pre class="prettyprint linenums"> public class EchoServer {

     public void bind(int port) throws Exception {<br />
         // NIO线程组<br />
         EventLoopGroup bossGroup = new NioEventLoopGroup();<br />
         EventLoopGroup workerGroup = new NioEventLoopGroup();

         try {<br />
             ServerBootstrap b = new ServerBootstrap();<br />
             b.group(bossGroup, workerGroup)<br />
                 .channel(NioServerSocketChannel.class)<br />
                 .option(ChannelOption.SO_BACKLOG, 1024)<br />
                 .childHandler(new ChildChannelHandler());

             // 绑定端口，同步等待成功<br />
             ChannelFuture f = b.bind(port).sync();<br />
             // 等待服务端监听端口关闭<br />
             f.channel().closeFuture().sync();<br />
         } finally {<br />
             // 优雅退出，释放线程池资源<br />
             bossGroup.shutdownGracefully();<br />
             workerGroup.shutdownGracefully();<br />
         }<br />
     }

     private class ChildChannelHandler extends ChannelInitializer&lt;SocketChannel&gt; {<br />
         @Override<br />
         protected void initChannel(SocketChannel arg0) throws Exception {<br />
             ByteBuf delimiter = Unpooled.copiedBuffer("$_".getBytes());

             arg0.pipeline().addLast(new DelimiterBasedFrameDecoder(1024, delimiter));<br />
             arg0.pipeline().addLast(new StringDecoder());<br />
             arg0.pipeline().addLast(new EchoServerHandler());<br />
         }<br />
     }

 }</pre>
</div>
<p>接着是EchoServerHandler，将接收到的消息打印出来，并记录收到的消息次数：</p>
<div>
<pre class="prettyprint linenums"> public class EchoServerHandler extends ChannelHandlerAdapter {

     private int counter = 0;

     @Override<br />
     public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {<br />
         String body = (String)msg;<br />
         System.out.println("This is " + ++counter + " times receive client:[" + body + "]");

         body += "$_";<br />
         ByteBuf echo = Unpooled.copiedBuffer(body.getBytes());<br />
         ctx.writeAndFlush(echo);<br />
     }

     @Override<br />
     public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {<br />
         cause.printStackTrace();<br />
         ctx.close();<br />
     }

 }</pre>
</div>
<p>收到消息之后，将消息加上"$_"回给客户端。看下客户端EchoClient的写法，也是一样，加上DelimiterBasedFrameDecoder：</p>
<div>
<pre class="prettyprint linenums"> public class EchoClient {

     public void connect(int port, String host) throws Exception {<br />
         EventLoopGroup group = new NioEventLoopGroup();<br />
         try {<br />
             Bootstrap b = new Bootstrap();

             b.group(group)<br />
                 .channel(NioSocketChannel.class)<br />
                 .option(ChannelOption.TCP_NODELAY, true)<br />
                 .handler(new ChannelInitializer&lt;SocketChannel&gt;() {<br />
                     protected void initChannel(SocketChannel ch) throws Exception {<br />
                         ByteBuf delimiter = Unpooled.copiedBuffer("$_".getBytes());

                         ch.pipeline().addLast(new DelimiterBasedFrameDecoder(1024, delimiter));<br />
                         ch.pipeline().addLast(new StringDecoder());<br />
                         ch.pipeline().addLast(new EchoClientHandler());<br />
                     };<br />
                 });

             // 发起异步连接操作<br />
             ChannelFuture f = b.connect(host, port).sync();<br />
             // 等待客户端连接关闭<br />
             f.channel().closeFuture().sync();<br />
         } finally {<br />
             // 优雅退出，释放NIO线程组<br />
             group.shutdownGracefully();<br />
         }<br />
     }

 }</pre>
</div>
<p>写一个EchoClientHandler，发送10条消息到Server并记录从Server回来的数据：</p>
<div>
<pre class="prettyprint linenums"> public class EchoClientHandler extends ChannelHandlerAdapter {

     private int counter;

     private static final String ECHO_REQ = "Hi, RickyXu, Welcome to Netty.$_";

     public EchoClientHandler() {

     }

     @Override<br />
     public void channelActive(ChannelHandlerContext ctx) throws Exception {<br />
         for (int i = 0; i &lt; 10; i++) {<br />
             ctx.writeAndFlush(Unpooled.copiedBuffer(ECHO_REQ.getBytes()));<br />
         }<br />
     }

     @Override<br />
     public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {<br />
         System.out.println("This is" + ++counter + " times receive server:[" + msg + "]");<br />
     }

     @Override<br />
     public void channelReadComplete(ChannelHandlerContext ctx) throws Exception {<br />
         ctx.flush();<br />
     }

     @Override<br />
     public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {<br />
         cause.printStackTrace();<br />
         ctx.close();<br />
     }

 }</pre>
</div>
<p>先运行服务端代码再运行客户端代码，看下服务端收到的数据为：</p>
<div>
<pre class="prettyprint linenums">This is 1 times receive client:[Hi, RickyXu, Welcome to Netty.]<br />
This is 2 times receive client:[Hi, RickyXu, Welcome to Netty.]<br />
This is 3 times receive client:[Hi, RickyXu, Welcome to Netty.]<br />
This is 4 times receive client:[Hi, RickyXu, Welcome to Netty.]<br />
This is 5 times receive client:[Hi, RickyXu, Welcome to Netty.]<br />
This is 6 times receive client:[Hi, RickyXu, Welcome to Netty.]<br />
This is 7 times receive client:[Hi, RickyXu, Welcome to Netty.]<br />
This is 8 times receive client:[Hi, RickyXu, Welcome to Netty.]<br />
This is 9 times receive client:[Hi, RickyXu, Welcome to Netty.]<br />
This is 10 times receive client:[Hi, RickyXu, Welcome to Netty.]</pre>
</div>
<p>一模一样收到10条且末尾的分隔符被忽略，客户端收到的响应为：</p>
<div>
<pre class="prettyprint linenums">This is 1 times receive server:[Hi, RickyXu, Welcome to Netty.]<br />
This is 2 times receive server:[Hi, RickyXu, Welcome to Netty.]<br />
This is 3 times receive server:[Hi, RickyXu, Welcome to Netty.]<br />
This is 4 times receive server:[Hi, RickyXu, Welcome to Netty.]<br />
This is 5 times receive server:[Hi, RickyXu, Welcome to Netty.]<br />
This is 6 times receive server:[Hi, RickyXu, Welcome to Netty.]<br />
This is 7 times receive server:[Hi, RickyXu, Welcome to Netty.]<br />
This is 8 times receive server:[Hi, RickyXu, Welcome to Netty.]<br />
This is 9 times receive server:[Hi, RickyXu, Welcome to Netty.]<br />
This is 10 times receive server:[Hi, RickyXu, Welcome to Netty.]</pre>
</div>
<p>同样收到了10条数据且忽略了末尾的换行符。</p>
<p>这样我们就通过一个示例演示了使用DelimiterBasedFrameDecoder解决TCP粘包/拆包，下面看一下使用FixedLengthFrameDecoder解决TCP粘包/拆包的示例。</p>
<p><strong>基于FixedLengthFrameDecoder的TCP粘包/拆包解决方案</strong></p>
<p>FixedLengthFrameDecoder是固定长度解码器，它能够按照指定的长度对消息进行自动解码，开发者不需要考虑TCP的粘包/拆包问题，非常实用，</p>
<p>同样看一下例子，先写一个EchoServer，加入FixedLengthFrameDecoder：</p>
<div>
<pre class="prettyprint linenums">public class EchoServer {

    public void bind(int port) throws Exception {<br />
        // NIO线程组<br />
        EventLoopGroup bossGroup = new NioEventLoopGroup();<br />
        EventLoopGroup workerGroup = new NioEventLoopGroup();

        try {<br />
            ServerBootstrap b = new ServerBootstrap();<br />
            b.group(bossGroup, workerGroup)<br />
                .channel(NioServerSocketChannel.class)<br />
                .option(ChannelOption.SO_BACKLOG, 1024)<br />
                .childHandler(new ChildChannelHandler());

            // 绑定端口，同步等待成功<br />
            ChannelFuture f = b.bind(port).sync();<br />
            // 等待服务端监听端口关闭<br />
            f.channel().closeFuture().sync();<br />
        } finally {<br />
            // 优雅退出，释放线程池资源<br />
            bossGroup.shutdownGracefully();<br />
            workerGroup.shutdownGracefully();<br />
        }<br />
    }

    private class ChildChannelHandler extends ChannelInitializer&lt;SocketChannel&gt; {<br />
        @Override<br />
        protected void initChannel(SocketChannel arg0) throws Exception {<br />
            arg0.pipeline().addLast(new FixedLengthFrameDecoder(20));<br />
            arg0.pipeline().addLast(new StringDecoder());<br />
            arg0.pipeline().addLast(new EchoServerHandler());<br />
        }<br />
    }

}</pre>
</div>
<p>接着下一下EchoServerHandler，EchoServerHandler比较简单：</p>
<div>
<pre class="prettyprint linenums">public class EchoServerHandler extends ChannelHandlerAdapter {

     @Override<br />
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {<br />
        System.out.println("Receive client:[" + msg + "]");<br />
    }

    @Override<br />
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {<br />
        cause.printStackTrace();<br />
        ctx.close();<br />
    }

}</pre>
</div>
<p>这里只打印接收到的数据，因为我们使用telnet来模拟发送请求而不是写一个EchoClient。首先telnet一下localhost 8080：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/801753/201804/801753-20180407194844402-1335123811.png" /></p>
<p>接着使用"Ctrl+]"：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/801753/201804/801753-20180407195011815-746581089.png" /></p>
<p>输入回车，这样就变成了回显模式，即输入什么看到什么，简单说一下telnet原理：</p>
<ol><li>建立与服务器的TCP连接</li>
<li>从键盘上接收输入的字符</li>
<li>把输入的字符变成标准格式并发送给服务器</li>
<li>从服务器接收输出的信息</li>
<li>输出的信息显示在屏幕/控制台上</li></ol>
<p>注意一下第2点+第3点，这里是键盘上输入一个字符就会发送这个字符到服务端的，对这点有疑问的可以在FixedLengthFrameDecoder的decode方法上打断点，就可以看到每输入一个字符，断点就会进入一次。</p>
<p>接着我们"0123456789"这样一直循环输入，FixedLengthFrameDecoder设置的Length是20，按照上面的解释，这样的话应该输入两轮"0123456789"即第二个9输入之后，控制台上就会打印了：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/801753/201804/801753-20180407195612287-1978659911.png" /></p>
<p>看一下控制台：</p>
<div>
<pre class="prettyprint linenums">Receive client:[01234567890123456789]</pre>
</div>
<p>没毛病，证明了FixedLengthFrameDecoder确实是按照定长接收包的，<strong>如果收到的包是半包消息，FixedLengthFrameDecoder会缓存半包消息并等待下个包到达之后进行拼包，直到读取到一个完整的包</strong>。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8er7keq.html">XPath的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p2z3y8.html">VS 2015打开项目闪退，新建项目提示未将对象引用到实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvprwxq.html">一些常用的C&plus;&plus;标准函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7y04gq.html">plist文件真机写入方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1pr7r9.html">ubuntu中常用快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmjmjz9.html">JavaScript中类的实现机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn12mzx8.html">python编码问题&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j0ryl8.html">一次young gc耗时过长优化过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljv2we9.html">jvm系列 &lpar;二&rpar; ---垃圾收集器与内存分配策略</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzopk08.html">一线互联网企业常见的14个Java面试题，Java面试题集大全等你拿，颤抖吧程序员！</a>
		</li>
						<li><a href="https://www.batexi.com/a/960j7nv9.html">Unity3d外包&mdash;就找北京动点软件（长年承接Unity3d软件、游戏项目外包）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g0k6eq.html">h5页面转图片长按保存</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jnxoeq.html">Linux下C语言进程通讯编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwgmzy8.html">sublime插件之px转rem</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5wydrq.html">&lbrack;转&rsqb;Angular2-组件间数据传递的两种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rgpg49.html">SpringBoot&lpar;2&period;0&period;4&period;RELEASE&rpar;&plus;Elasticsearch&lpar;6&period;2&period;4&rpar;&plus;Gradle简单整合</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g5mo6q.html">springMVC容器和Spring容器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2pxge8.html">react native系列 - 从零开始构建</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmkpzl9.html">Simple microcontroller-temperature measurement uses only a diode and a capacitor</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15m0wz9.html">Highcharts 基本曲线图；Highcharts 带有数据标签曲线图表；Highcharts 异步加载数据曲线图表</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96pw1748.html">SSM-SpringMVC-10：SpringMVC中PropertiesMethodNameResolver属性方法名称解析器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1mxmjq.html">关于Linux虚拟化技术KVM的科普</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkm0we8.html">使用SQL命令批量替换WordPress站点中图片的URL链接地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpypdxq.html">Python configparser 读取指定节点内容失败</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pr0d48.html">fastjson使用中遇到的</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzoml48.html">BZOJ&lowbar;1146&lowbar;&lbrack;CTSC2008&rsqb;网络管理Network&lowbar;主席树&plus;树状数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z57je9.html">【爆料】-《昆士兰大学毕业证书》Queensland一模一样原件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg243m8.html">python3环境搭建（uWSGI&plus;django&plus;nginx&plus;python&plus;MySQL）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jzm6o8.html">转载  python实例手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1y05jq.html">Universal-Image-Loader源码解解析---display过程 &plus; 获取bitmap过程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
